//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
#include "CSPIN.h"
#include "ievect.hpp"
#include "ieview.hpp"
#include "imageenview.hpp"
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
#include "ievect.hpp"
#include "ieview.hpp"
#include "imageenview.hpp"
#include "cspin.h"
typedef double TFloat;
const MAX_DELAY_POINTS = 1024;
struct structSplinePoint
  {
  TFloat x, y;
  };
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TImageEnVect *IenVect1;
	TPanel *Panel1;
	TButton *Button1;
	TButton *Button2;
	TLabel *Label1;
	TCSpinEdit *CSpinEdit1;
	TMemo *Memo1;
	void __fastcall IenVect1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y);
	void __fastcall IenVect1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
private:	// User declarations
	int hobj, polyCount;
	TPoint  polyPoint[100000];
	TPoint __fastcall VecMinInt2D(TPoint A, TPoint B);
	TFloat __fastcall DotProdInt2D(TPoint A, TPoint B);
	TFloat __fastcall NormSquaredInt2D(TPoint A);
	TFloat __fastcall DistSquaredInt2D(TPoint A, TPoint B);
	void __fastcall DouglasPeucker2D(TFloat Tol2, TPoint *Orig,  TStringList *IndexList, int j, int k);
	void __fastcall simplifyPolyline(int max_pts);
	AnsiString __fastcall pxcf_PadLeft(AnsiString inp_str, int duzina, char pad_chr);
	// spline
	int splineCount, Resolution;
	TPoint splinePoint[MAX_DELAY_POINTS*20];
	structSplinePoint  A, B, C, D, P[MAX_DELAY_POINTS + 2];
	void __fastcall splinePointCR(double t, structSplinePoint *Point);
    void __fastcall splineComputeCoeffsCR (int n);
	int __fastcall  CalculateSplineCR(TPoint *poly_pts, TPoint *spline_pts, int poly_count);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
